searchData={"items":[{"type":"task","title":"mix rolex.gen.migration","doc":"Generates a migration to create a permissions table.","ref":"Mix.Tasks.Rolex.Gen.Migration.html"},{"type":"task","title":"Examples - mix rolex.gen.migration","doc":"$ mix rolex.gen.migration\n    $ mix rolex.gen.migration \"my_custom_table_name\"\n\nOptions, if any, are passed directly through to the underlying\n`ecto.gen.migration` task used to actually generate the migration.","ref":"Mix.Tasks.Rolex.Gen.Migration.html#module-examples"},{"type":"task","title":"mix rolex.regen.migration","doc":"Regenerates the permission table migration for dev and test migration purposes.","ref":"Mix.Tasks.Rolex.Regen.Migration.html"},{"type":"module","title":"Rolex","doc":"The main entry point for interacting with Rolex.","ref":"Rolex.html"},{"type":"function","title":"Rolex.deny/1","doc":"","ref":"Rolex.html#deny/1"},{"type":"function","title":"Rolex.deny!/1","doc":"","ref":"Rolex.html#deny!/1"},{"type":"function","title":"Rolex.deny_on/2","doc":"","ref":"Rolex.html#deny_on/2"},{"type":"function","title":"Rolex.deny_on!/2","doc":"","ref":"Rolex.html#deny_on!/2"},{"type":"function","title":"Rolex.deny_role/2","doc":"","ref":"Rolex.html#deny_role/2"},{"type":"function","title":"Rolex.deny_role!/2","doc":"","ref":"Rolex.html#deny_role!/2"},{"type":"function","title":"Rolex.deny_to/2","doc":"","ref":"Rolex.html#deny_to/2"},{"type":"function","title":"Rolex.deny_to!/2","doc":"","ref":"Rolex.html#deny_to!/2"},{"type":"function","title":"Rolex.grant/1","doc":"","ref":"Rolex.html#grant/1"},{"type":"function","title":"Rolex.grant!/1","doc":"","ref":"Rolex.html#grant!/1"},{"type":"function","title":"Rolex.grant_on/2","doc":"","ref":"Rolex.html#grant_on/2"},{"type":"function","title":"Rolex.grant_on!/2","doc":"","ref":"Rolex.html#grant_on!/2"},{"type":"function","title":"Rolex.grant_role/2","doc":"","ref":"Rolex.html#grant_role/2"},{"type":"function","title":"Rolex.grant_role!/2","doc":"","ref":"Rolex.html#grant_role!/2"},{"type":"function","title":"Rolex.grant_to/2","doc":"","ref":"Rolex.html#grant_to/2"},{"type":"function","title":"Rolex.grant_to!/2","doc":"","ref":"Rolex.html#grant_to!/2"},{"type":"function","title":"Rolex.granted?/2","doc":"","ref":"Rolex.html#granted?/2"},{"type":"function","title":"Rolex.granted_on?/3","doc":"","ref":"Rolex.html#granted_on?/3"},{"type":"function","title":"Rolex.granted_role?/3","doc":"","ref":"Rolex.html#granted_role?/3"},{"type":"function","title":"Rolex.granted_to?/3","doc":"","ref":"Rolex.html#granted_to?/3"},{"type":"function","title":"Rolex.load_permissions_granted_to/1","doc":"Fetches from the database a list of all permissions granted to `subject`.\n\nThis list can subsequently be used for in-memory permission checks by e.g. `granted_role?/3`.","ref":"Rolex.html#load_permissions_granted_to/1"},{"type":"function","title":"Rolex.multi_deny/2","doc":"","ref":"Rolex.html#multi_deny/2"},{"type":"function","title":"Rolex.multi_deny_on/3","doc":"","ref":"Rolex.html#multi_deny_on/3"},{"type":"function","title":"Rolex.multi_deny_role/3","doc":"","ref":"Rolex.html#multi_deny_role/3"},{"type":"function","title":"Rolex.multi_deny_to/3","doc":"","ref":"Rolex.html#multi_deny_to/3"},{"type":"function","title":"Rolex.multi_grant/2","doc":"","ref":"Rolex.html#multi_grant/2"},{"type":"function","title":"Rolex.multi_grant_on/3","doc":"","ref":"Rolex.html#multi_grant_on/3"},{"type":"function","title":"Rolex.multi_grant_role/3","doc":"","ref":"Rolex.html#multi_grant_role/3"},{"type":"function","title":"Rolex.multi_grant_to/3","doc":"","ref":"Rolex.html#multi_grant_to/3"},{"type":"function","title":"Rolex.multi_revoke/2","doc":"","ref":"Rolex.html#multi_revoke/2"},{"type":"function","title":"Rolex.multi_revoke_from/3","doc":"","ref":"Rolex.html#multi_revoke_from/3"},{"type":"function","title":"Rolex.multi_revoke_on/3","doc":"","ref":"Rolex.html#multi_revoke_on/3"},{"type":"function","title":"Rolex.multi_revoke_role/3","doc":"","ref":"Rolex.html#multi_revoke_role/3"},{"type":"function","title":"Rolex.preload_permissions/2","doc":"","ref":"Rolex.html#preload_permissions/2"},{"type":"function","title":"Rolex.revoke/1","doc":"","ref":"Rolex.html#revoke/1"},{"type":"function","title":"Rolex.revoke!/1","doc":"","ref":"Rolex.html#revoke!/1"},{"type":"function","title":"Rolex.revoke_from/2","doc":"","ref":"Rolex.html#revoke_from/2"},{"type":"function","title":"Rolex.revoke_from!/2","doc":"","ref":"Rolex.html#revoke_from!/2"},{"type":"function","title":"Rolex.revoke_on/2","doc":"","ref":"Rolex.html#revoke_on/2"},{"type":"function","title":"Rolex.revoke_on!/2","doc":"","ref":"Rolex.html#revoke_on!/2"},{"type":"function","title":"Rolex.revoke_role/2","doc":"","ref":"Rolex.html#revoke_role/2"},{"type":"function","title":"Rolex.revoke_role!/2","doc":"","ref":"Rolex.html#revoke_role!/2"},{"type":"function","title":"Rolex.where_granted_on/2","doc":"","ref":"Rolex.html#where_granted_on/2"},{"type":"function","title":"Rolex.where_granted_to/2","doc":"","ref":"Rolex.html#where_granted_to/2"},{"type":"module","title":"Rolex.Check","doc":"Functions for checking permissions.","ref":"Rolex.Check.html"},{"type":"function","title":"Rolex.Check.filter_granted/2","doc":"Filters granted permissions per DSL options.","ref":"Rolex.Check.html#filter_granted/2"},{"type":"function","title":"Rolex.Check.filter_granted_on/3","doc":"Filters granted permissions per DSL options, prefilling `on: object`.","ref":"Rolex.Check.html#filter_granted_on/3"},{"type":"function","title":"Rolex.Check.filter_granted_to/3","doc":"Filters granted permissions per DSL options, prefilling `to: subject`.","ref":"Rolex.Check.html#filter_granted_to/3"},{"type":"function","title":"Rolex.Check.granted?/2","doc":"Returns true if given any granted permissions that meet DSL filtering options.","ref":"Rolex.Check.html#granted?/2"},{"type":"function","title":"Rolex.Check.granted_on?/3","doc":"Returns true if given any granted permissions that meet DSL filtering options, prefilling `on: object`.","ref":"Rolex.Check.html#granted_on?/3"},{"type":"function","title":"Rolex.Check.granted_role?/3","doc":"Returns true if given any granted permissions that meet DSL filtering options, prefilling `role: role`.","ref":"Rolex.Check.html#granted_role?/3"},{"type":"function","title":"Rolex.Check.granted_to?/3","doc":"Returns true if given any granted permissions that meet DSL filtering options, prefilling `to: subject`.","ref":"Rolex.Check.html#granted_to?/3"},{"type":"function","title":"Rolex.Check.roles_granted/1","doc":"","ref":"Rolex.Check.html#roles_granted/1"},{"type":"type","title":"Rolex.Check.any_on_opt/0","doc":"","ref":"Rolex.Check.html#t:any_on_opt/0"},{"type":"type","title":"Rolex.Check.any_role/0","doc":"","ref":"Rolex.Check.html#t:any_role/0"},{"type":"type","title":"Rolex.Check.any_role_opt/0","doc":"","ref":"Rolex.Check.html#t:any_role_opt/0"},{"type":"type","title":"Rolex.Check.any_scope/0","doc":"","ref":"Rolex.Check.html#t:any_scope/0"},{"type":"type","title":"Rolex.Check.any_to_opt/0","doc":"","ref":"Rolex.Check.html#t:any_to_opt/0"},{"type":"module","title":"Rolex.Control","doc":"Provides functions for granting, denying, and revoking permissions.","ref":"Rolex.Control.html"},{"type":"function","title":"Rolex.Control.deny/1","doc":"Creates a role-denying permission from DSL options.\n\nReturns `:ok` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#deny/1"},{"type":"function","title":"Rolex.Control.deny!/1","doc":"Creates a role-denying permission from DSL options.\n\nReturns `:ok` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#deny!/1"},{"type":"function","title":"Rolex.Control.deny_on/2","doc":"Creates a role-denying permission from DSL options, prefilling `on: object`.\n\nReturns `{:ok, object}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#deny_on/2"},{"type":"function","title":"Rolex.Control.deny_on!/2","doc":"Creates a role-denying permission from DSL options, prefilling `on: object`.\n\nReturns `object` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#deny_on!/2"},{"type":"function","title":"Rolex.Control.deny_role/2","doc":"Creates a role-denying permission from DSL options, prefilling `role: role`.\n\nReturns `{:ok, role}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#deny_role/2"},{"type":"function","title":"Rolex.Control.deny_role!/2","doc":"Creates a role-denying permission from DSL options, prefilling `role: role`.\n\nReturns `role` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#deny_role!/2"},{"type":"function","title":"Rolex.Control.deny_to/2","doc":"Creates a role-denying permission from DSL options, prefilling `to: subject`.\n\nReturns `{:ok, subject}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#deny_to/2"},{"type":"function","title":"Rolex.Control.deny_to!/2","doc":"Creates a role-denying permission from DSL options, prefilling `to: subject`.\n\nReturns `subject` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#deny_to!/2"},{"type":"function","title":"Rolex.Control.grant/1","doc":"Creates a role-granting permission from DSL options.\n\nReturns `:ok` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#grant/1"},{"type":"function","title":"Rolex.Control.grant!/1","doc":"Creates a role-granting permission from DSL options.\n\nReturns `:ok` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#grant!/1"},{"type":"function","title":"Rolex.Control.grant_on/2","doc":"Creates a role-granting permission from DSL options, prefilling `on: object`.\n\nReturns `{:ok, object}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#grant_on/2"},{"type":"function","title":"Rolex.Control.grant_on!/2","doc":"Creates a role-granting permission from DSL options, prefilling `on: object`.\n\nReturns `object` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#grant_on!/2"},{"type":"function","title":"Rolex.Control.grant_role/2","doc":"Creates a role-granting permission from DSL options, prefilling `role: role`.\n\nReturns `{:ok, role}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#grant_role/2"},{"type":"function","title":"Rolex.Control.grant_role!/2","doc":"Creates a role-granting permission from DSL options, prefilling `role: role`.\n\nReturns `role` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#grant_role!/2"},{"type":"function","title":"Rolex.Control.grant_to/2","doc":"Creates a role-granting permission from DSL options, prefilling `to: subject`.\n\nReturns `{:ok, subject}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#grant_to/2"},{"type":"function","title":"Rolex.Control.grant_to!/2","doc":"Creates a role-granting permission from DSL options, prefilling `to: subject`.\n\nReturns `subject` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#grant_to!/2"},{"type":"function","title":"Rolex.Control.multi_deny/2","doc":"Adds a multi operation to create a role-denying permission from DSL options.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_deny/2"},{"type":"function","title":"Rolex.Control.multi_deny_on/3","doc":"Adds a multi operation to create a role-denying permission from DSL options, prefilling `on: object`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_deny_on/3"},{"type":"function","title":"Rolex.Control.multi_deny_role/3","doc":"Adds a multi operation to create a role-denying permission from DSL options, prefilling `role: role`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_deny_role/3"},{"type":"function","title":"Rolex.Control.multi_deny_to/3","doc":"Adds a multi operation to create a role-denying permission from DSL options, prefilling `to: subject`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_deny_to/3"},{"type":"function","title":"Rolex.Control.multi_grant/2","doc":"Adds a multi operation to create a role-granting permission from DSL options.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_grant/2"},{"type":"function","title":"Rolex.Control.multi_grant_on/3","doc":"Adds a multi operation to create a role-granting permission from DSL options, prefilling `on: object`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_grant_on/3"},{"type":"function","title":"Rolex.Control.multi_grant_role/3","doc":"Adds a multi operation to create a role-granting permission from DSL options, prefilling `role: role`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_grant_role/3"},{"type":"function","title":"Rolex.Control.multi_grant_to/3","doc":"Adds a multi operation to create a role-granting permission from DSL options, prefilling `to: subject`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_grant_to/3"},{"type":"function","title":"Rolex.Control.multi_revoke/2","doc":"Adds a multi operation to delete all permissions matching the given DSL options.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_revoke/2"},{"type":"function","title":"Rolex.Control.multi_revoke_from/3","doc":"Adds a multi operation to delete all permissions matching the given DSL options, prefilling `from: subject`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_revoke_from/3"},{"type":"function","title":"Rolex.Control.multi_revoke_on/3","doc":"Adds a multi operation to delete all permissions matching the given DSL options, prefilling `on: object`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_revoke_on/3"},{"type":"function","title":"Rolex.Control.multi_revoke_role/3","doc":"Adds a multi operation to delete all permissions matching the given DSL options, prefilling `role: role`.\n\nReturns the updated multi.","ref":"Rolex.Control.html#multi_revoke_role/3"},{"type":"function","title":"Rolex.Control.revoke/1","doc":"Deletes all permissions matching the given DSL options.\n\nReturns `{:ok,  }` on success, or `{:error, changeset}` otherwise.","ref":"Rolex.Control.html#revoke/1"},{"type":"function","title":"Rolex.Control.revoke!/1","doc":"Deletes all permissions matching the given DSL options.\n\nReturns the number of permissions deleted on success, or raises an exception otherwise.","ref":"Rolex.Control.html#revoke!/1"},{"type":"function","title":"Rolex.Control.revoke_from/2","doc":"Deletes all permissions matching the given DSL options, prefilling `from: subject`.\n\nReturns `{:ok, subject}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#revoke_from/2"},{"type":"function","title":"Rolex.Control.revoke_from!/2","doc":"Deletes all permissions matching the given DSL options, prefilling `from: subject`.\n\nReturns `subject` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#revoke_from!/2"},{"type":"function","title":"Rolex.Control.revoke_on/2","doc":"Deletes all permissions matching the given DSL options, prefilling `on: object`.\n\nReturns `{:ok, object}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#revoke_on/2"},{"type":"function","title":"Rolex.Control.revoke_on!/2","doc":"Deletes all permissions matching the given DSL options, prefilling `on: object`.\n\nReturns `object` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#revoke_on!/2"},{"type":"function","title":"Rolex.Control.revoke_role/2","doc":"Deletes all permissions matching the given DSL options, prefilling `role: role`.\n\nReturns `{:ok, role}` on success, or `{:error, reason}` otherwise.","ref":"Rolex.Control.html#revoke_role/2"},{"type":"function","title":"Rolex.Control.revoke_role!/2","doc":"Deletes all permissions matching the given DSL options, prefilling `role: role`.\n\nReturns `role` on success, or raises an exception otherwise.","ref":"Rolex.Control.html#revoke_role!/2"},{"type":"type","title":"Rolex.Control.any_from_opt/0","doc":"","ref":"Rolex.Control.html#t:any_from_opt/0"},{"type":"type","title":"Rolex.Control.any_on_opt/0","doc":"","ref":"Rolex.Control.html#t:any_on_opt/0"},{"type":"type","title":"Rolex.Control.any_role/0","doc":"","ref":"Rolex.Control.html#t:any_role/0"},{"type":"type","title":"Rolex.Control.any_role_opt/0","doc":"","ref":"Rolex.Control.html#t:any_role_opt/0"},{"type":"type","title":"Rolex.Control.any_scope/0","doc":"","ref":"Rolex.Control.html#t:any_scope/0"},{"type":"type","title":"Rolex.Control.any_to_opt/0","doc":"","ref":"Rolex.Control.html#t:any_to_opt/0"},{"type":"type","title":"Rolex.Control.from_opt/0","doc":"","ref":"Rolex.Control.html#t:from_opt/0"},{"type":"type","title":"Rolex.Control.multi/0","doc":"","ref":"Rolex.Control.html#t:multi/0"},{"type":"type","title":"Rolex.Control.on_opt/0","doc":"","ref":"Rolex.Control.html#t:on_opt/0"},{"type":"type","title":"Rolex.Control.role/0","doc":"","ref":"Rolex.Control.html#t:role/0"},{"type":"type","title":"Rolex.Control.role_opt/0","doc":"","ref":"Rolex.Control.html#t:role_opt/0"},{"type":"type","title":"Rolex.Control.scope/0","doc":"","ref":"Rolex.Control.html#t:scope/0"},{"type":"type","title":"Rolex.Control.to_opt/0","doc":"","ref":"Rolex.Control.html#t:to_opt/0"},{"type":"module","title":"Rolex.DSL","doc":"Implements a small domain-specific language (\"DSL\") for scoping permissions.\n\nThe DSL is defined by a handful of keyword options:\n\n  * `:role` - a plain atom naming the role\n  * `:to` - specifies the subject scope; i.e. \"who holds the role?\"\n  * `:on` - specifics the object scope; i.e. \"on which resources does the role apply?\n\n> When revoking permissions, `from` is used in place of `to`, because it reads more naturally.\n\nSubject and object scopes are specified using any of these values:\n\n  * `:all` - a special atom for granting or denying ALL of something\n  * any Ecto schema module; e.g. `MyApp.Users.User`\n  * any Ecto schema record; e.g. `%MyApp.Users.User{id: 123}`","ref":"Rolex.DSL.html"},{"type":"function","title":"Rolex.DSL.changeset/2","doc":"Returns a changeset for DSL options used to perform `action`.\n\nAction may be any of `:grant`, `:deny`, `:revoke`, `:filter`.","ref":"Rolex.DSL.html#changeset/2"},{"type":"function","title":"Rolex.DSL.changeset_for_filter/1","doc":"Returns a changeset for options used when filtering permissions.","ref":"Rolex.DSL.html#changeset_for_filter/1"},{"type":"function","title":"Options: - Rolex.DSL.changeset_for_filter/1","doc":"* `:role` - a plain atom naming a role, or:\n    * `:any` - will match **any** permission role\n  * `:to` - `:all`, schema, record, or:\n    * `:any` - will match **any** permission subject\n    * `{:any,  }` - will match **any** permission subject of the named schema\n  * `:on` - `:all`, schema, record, or:\n    * `:any` - will match **any** permission object\n    * `{:any,  }` - will match **any** permission object of the named schema","ref":"Rolex.DSL.html#changeset_for_filter/1-options"},{"type":"function","title":"Rolex.DSL.changeset_for_grant_or_deny/1","doc":"Returns a changeset for DSL options used when granting or denying permissions.","ref":"Rolex.DSL.html#changeset_for_grant_or_deny/1"},{"type":"function","title":"Options: - Rolex.DSL.changeset_for_grant_or_deny/1","doc":"* `:role` - a plain atom naming a role\n  * `:to` - `:all`, schema, or record\n  * `:on` - `:all`, schema, or record","ref":"Rolex.DSL.html#changeset_for_grant_or_deny/1-options"},{"type":"function","title":"Rolex.DSL.changeset_for_revoke/1","doc":"Returns a changeset for options used when revoking permissions.","ref":"Rolex.DSL.html#changeset_for_revoke/1"},{"type":"function","title":"Options: - Rolex.DSL.changeset_for_revoke/1","doc":"* `:role` - a plain atom naming a role, or:\n    * `:any` - will match **any** permission role\n  * `:from` - `:all`, schema, record, or:\n    * `:any` - will match **any** permission subject\n    * `{:any,  }` - will match **any** permission subject of the named schema\n  * `:on` - `:all`, schema, record, or:\n    * `:any` - will match **any** permission object\n    * `{:any,  }` - will match **any** permission object of the named schema","ref":"Rolex.DSL.html#changeset_for_revoke/1-options"},{"type":"function","title":"Rolex.DSL.new/1","doc":"Returns a new `m:Rolex.DSL` initialized from `input` on success, or `{:error, reason}` otherwise.","ref":"Rolex.DSL.html#new/1"},{"type":"function","title":"Rolex.DSL.to_permission_params/1","doc":"Converts `input` from external DSL options to internal `m:Rolex.Permission` schema params.\n\nReturns an atom-keyed map on success, or an `{:error, reason}` tuple otherwise.","ref":"Rolex.DSL.html#to_permission_params/1"},{"type":"type","title":"Rolex.DSL.action/0","doc":"","ref":"Rolex.DSL.html#t:action/0"},{"type":"type","title":"Rolex.DSL.any_from_opt/0","doc":"","ref":"Rolex.DSL.html#t:any_from_opt/0"},{"type":"type","title":"Rolex.DSL.any_on_opt/0","doc":"","ref":"Rolex.DSL.html#t:any_on_opt/0"},{"type":"type","title":"Rolex.DSL.any_role/0","doc":"","ref":"Rolex.DSL.html#t:any_role/0"},{"type":"type","title":"Rolex.DSL.any_role_opt/0","doc":"","ref":"Rolex.DSL.html#t:any_role_opt/0"},{"type":"type","title":"Rolex.DSL.any_scope/0","doc":"","ref":"Rolex.DSL.html#t:any_scope/0"},{"type":"type","title":"Rolex.DSL.any_to_opt/0","doc":"","ref":"Rolex.DSL.html#t:any_to_opt/0"},{"type":"type","title":"Rolex.DSL.changeset/0","doc":"","ref":"Rolex.DSL.html#t:changeset/0"},{"type":"type","title":"Rolex.DSL.filter_option/0","doc":"","ref":"Rolex.DSL.html#t:filter_option/0"},{"type":"type","title":"Rolex.DSL.from_opt/0","doc":"","ref":"Rolex.DSL.html#t:from_opt/0"},{"type":"type","title":"Rolex.DSL.on_opt/0","doc":"","ref":"Rolex.DSL.html#t:on_opt/0"},{"type":"type","title":"Rolex.DSL.record/0","doc":"","ref":"Rolex.DSL.html#t:record/0"},{"type":"type","title":"Rolex.DSL.revoke_option/0","doc":"","ref":"Rolex.DSL.html#t:revoke_option/0"},{"type":"type","title":"Rolex.DSL.role/0","doc":"","ref":"Rolex.DSL.html#t:role/0"},{"type":"type","title":"Rolex.DSL.role_opt/0","doc":"","ref":"Rolex.DSL.html#t:role_opt/0"},{"type":"type","title":"Rolex.DSL.schema/0","doc":"","ref":"Rolex.DSL.html#t:schema/0"},{"type":"type","title":"Rolex.DSL.scope/0","doc":"","ref":"Rolex.DSL.html#t:scope/0"},{"type":"type","title":"Rolex.DSL.t/0","doc":"","ref":"Rolex.DSL.html#t:t/0"},{"type":"type","title":"Rolex.DSL.to_opt/0","doc":"","ref":"Rolex.DSL.html#t:to_opt/0"},{"type":"module","title":"Rolex.Permission","doc":"Permissions are the basic units of role assignments.\n\nA permission is an intersection of four pieces of information:\n\n  * verb - either \"grant\" or \"deny\"\n  * role - the role being granted or denied\n  * subject - the entity (or entities) being granted or denied the role\n  * object - the entity (or entities) on which the subject is being granted the role\n\nFor example, a permission that \"grants admin to user 42 on all tasks\" would look like this:\n\n```elixir\n%Permission{verb: :grant, role: :admin, subject_type: User, subject_id: 42, object_type: Task, object_id: :all}\n```\n\nA permission \"applies\" to any arbitrary subject and/or object if the corresponding `_type` and `_id`\nfields are either `:all` or a perfect match. This particular permission applies only if the subject\nis specifically `%User{id: 42}` *and* the object is a task; e.g. `%Task{id: 123}`.\n\nRolex inspects the full set of applicable permissions to make a final determination about each\nrole. If this were the only permission, with subject `%User{id: 42}` and object `%Task{id: _}`,\nthe `:admin` role is granted.\n\nWe can make exceptions by creating \"deny\" permissions. Continuing our example, suppose we\nnow wanted to \"deny admin to all subjects on task 99\".\n\n```elixir\n%Permission{verb: :deny, role: :admin, subject_type: :all, subject_id: :all, object_type: Task, object_id: 99}\n```\n\nThis permission applies to *all* subjects (regardless of type or id!), but only if the object is\nspecifically `%Task{id: 99}`.\n\nGiven these two permissions, with subject `%User{id: 42}` and object `%Task{id: 123}`, the `:admin`\nrole is granted. In object `%Task{id: 99}`'s case, however, the \"deny\" permission takes precedence,\nand the `:admin` role will *never* be granted.","ref":"Rolex.Permission.html"},{"type":"function","title":"Rolex.Permission.base_query/0","doc":"Returns an initialized `%Ecto.Query{}` to be used for permission queries.","ref":"Rolex.Permission.html#base_query/0"},{"type":"function","title":"Rolex.Permission.filter_granted/2","doc":"Narrows a list of permissions to grant permissions that are not overridden by a deny permission.","ref":"Rolex.Permission.html#filter_granted/2"},{"type":"function","title":"Rolex.Permission.preloader_query/2","doc":"","ref":"Rolex.Permission.html#preloader_query/2"},{"type":"function","title":"Rolex.Permission.where_equal/2","doc":"Narrows a permission query to those that match the passed parameters.\n\nUsed to target specific records, as when revoking permissions.","ref":"Rolex.Permission.html#where_equal/2"},{"type":"function","title":"Rolex.Permission.where_granted/2","doc":"Narrows a permission query to grant permissions that are not overridden by a deny permission.","ref":"Rolex.Permission.html#where_granted/2"},{"type":"type","title":"Rolex.Permission.action/0","doc":"","ref":"Rolex.Permission.html#t:action/0"},{"type":"type","title":"Rolex.Permission.changeset/0","doc":"","ref":"Rolex.Permission.html#t:changeset/0"},{"type":"type","title":"Rolex.Permission.params/0","doc":"","ref":"Rolex.Permission.html#t:params/0"},{"type":"opaque","title":"Rolex.Permission.t/0","doc":"","ref":"Rolex.Permission.html#t:t/0"},{"type":"module","title":"Rolex.Queryable","doc":"Provides role-based query scoping functions.","ref":"Rolex.Queryable.html"},{"type":"function","title":"Rolex.Queryable.preload_permissions/2","doc":"Adds permission preloading to the named association on a query.","ref":"Rolex.Queryable.html#preload_permissions/2"},{"type":"function","title":"Rolex.Queryable.preload_permissions/3","doc":"Preloads a named permission association on loaded records.","ref":"Rolex.Queryable.html#preload_permissions/3"},{"type":"function","title":"Rolex.Queryable.where_granted_on/2","doc":"Scopes `queryable` to records that are the object of a granted permission.\n\nRole and subject scope are narrowed by DSL options.","ref":"Rolex.Queryable.html#where_granted_on/2"},{"type":"function","title":"Options - Rolex.Queryable.where_granted_on/2","doc":"* `:role` - names the granted role\n  * `:to` - the permission subject (\"who\")","ref":"Rolex.Queryable.html#where_granted_on/2-options"},{"type":"function","title":"Examples - Rolex.Queryable.where_granted_on/2","doc":"# tasks where :some_role is granted to a particular user\n    iex> from(t in Task) |> where_granted_on(role: :some_role, to: user)","ref":"Rolex.Queryable.html#where_granted_on/2-examples"},{"type":"function","title":"Rolex.Queryable.where_granted_to/2","doc":"Scopes `queryable` to records that are the subject of a granted permission.\n\nRole and object scope are narrowed by DSL options.","ref":"Rolex.Queryable.html#where_granted_to/2"},{"type":"function","title":"Options - Rolex.Queryable.where_granted_to/2","doc":"* `:role` - names the granted role\n  * `:on` - the permission object (\"what\")","ref":"Rolex.Queryable.html#where_granted_to/2-options"},{"type":"function","title":"Examples - Rolex.Queryable.where_granted_to/2","doc":"# users where :some_role is granted on a particular task\n    iex> from(u in User) |> where_granted_to(role: :some_role, on: task)","ref":"Rolex.Queryable.html#where_granted_to/2-examples"},{"type":"type","title":"Rolex.Queryable.any_on_opt/0","doc":"","ref":"Rolex.Queryable.html#t:any_on_opt/0"},{"type":"type","title":"Rolex.Queryable.any_role_opt/0","doc":"","ref":"Rolex.Queryable.html#t:any_role_opt/0"},{"type":"type","title":"Rolex.Queryable.any_to_opt/0","doc":"","ref":"Rolex.Queryable.html#t:any_to_opt/0"},{"type":"extras","title":"Installing Rolex","doc":"# Installing Rolex\n\nAdd `rolex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:rolex, \"~> 0.5.0\"}\n  ]\nend\n```\n\nCreate and run a migration to set up the `permissions` table.\n\n```shell\n$ mix gen.migration\n* creating priv/repo/migrations/20240902155226_create_permissions.exs\n\n$ mix ecto.migrate\n10:54:04.292 [info] == Running 20240902155226 MyApp.Repo.Migrations.CreatePermissions.change/0 forward\n10:54:04.293 [info] create table permissions\n10:54:04.301 [info] create index permissions_unique_index\n10:54:04.303 [info] == Migrated 20240902155226 in 0.0s\n```\n\nConfigure Rolex so it knows which Ecto repo to work with and what your schemas use for IDs:\n\n```elixir\n# config.exs\nconfig :rolex, repo: MyApp.Repo, id_type: :binary_id\n```\n\nThat's it! You're ready to go.","ref":"installation.html"},{"type":"extras","title":"Permission control","doc":"# Permission control","ref":"control.html"},{"type":"extras","title":"Granting and denying roles - Permission control","doc":"{: .col-2}","ref":"control.html#granting-and-denying-roles"},{"type":"extras","title":"Granting roles to a user - Permission control","doc":"#### Grant a role, without restriction\n\n```elixir\nRolex.grant_to!(user, role: :admin, on: :all)\n```\n\n#### Grant a role on all records of a schema\n\n```elixir\nRolex.grant_to!(user, role: :approver, on: Task)\n```\n\n#### Grant a role on a single record\n\n```elixir\nRolex.grant_to!(user, role: :owner, on: task)\n```","ref":"control.html#granting-roles-to-a-user"},{"type":"extras","title":"Denying roles to a user - Permission control","doc":"#### Grants a role on all schema records **except** this one\n\n```elixir\nuser\n|> Rolex.grant_to!(role: :approver, on: Task)\n|> Rolex.deny_to!(role: :approver, on: task)\n```\nDenying a role **always** overrules granting that role.","ref":"control.html#denying-roles-to-a-user"},{"type":"extras","title":"Revoking roles - Permission control","doc":"{: .col-2}","ref":"control.html#revoking-roles"},{"type":"extras","title":"Undoing grants and denials - Permission control","doc":"#### Delete all grants and denials on a record\n\n```elixir\nRolex.revoke_from!(user, role: :approver, on: task)\n```\n\n#### Delete all grants and denials on any record of a schema\n\n```elixir\nRolex.revoke_from!(user, role: :approver, on: {:any, Task})\n```\n\n#### Delete all of a user's grants and denials\n\n```elixir\nRolex.revoke_from!(user, role: :any, on: :any)\n```","ref":"control.html#undoing-grants-and-denials"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}